# Introduction

EdimCoder is a line editor much like Ed. This means it manipulates one line at a time. However, because of the technology we have today, we don't have to settle for the minimalism and software limitations that Ed had. Therefore, EdimCoder provides various means of making text-editing easier with its line-editing style. This includes prompts, status lines, and context information for each command, among other things.

# Starting EdimCoder

You can start edimcoder by itself, in which case it will enter a -Scratch- buffer (more on this later), or by providing it a file, in which case it will open that file for editing.

As soon as you start EdimCoder, a command prompt is given.

## The Command Prompt

A command prompt is given to show useful and relevant information while inputting commands to manipulate the open file.

The command prompt gives the buffer number, the filename, and the *current line* (the term "current line" is used instead of "cursor" because the current line only represents a line number does not also represent a column, unlike screen-oriented editors).

<1: UserGuide.md|4>
 ^A ^B           ^C

A - buffer number
B - filename
C - current line number

## The Scratch Buffer

If you had opened edimcoder without providing it a file, the filename should show '-Scratch-'. This is the scratch buffer. The scratch buffer can be used by the user for notes, storing pieces of code temporarily, etc. The scratch buffer is *not* a file, but instead a special buffer that has no file associated with it and cannot be opened or saved.

## Buffers

Buffers are open files. A buffer stores the current modified state of a file in memory so that editing files is fast. Saving a buffer will write the modified state from memory to the disk.

